#!/usr/bin/env python2
#
# GEemyle: A GTK frontend to Eemyle
# Copyright (C) 2003-2006 Easter-eggs <info@easter-eggs.com>
# Authors:
#      Cyril Lacoux (Yack) <clacoux@easter-eggs.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

__author__  = "Cyril Lacoux [Yack] <clacoux@easter-eggs.com>"
__cvsid__   = "$Id$"
__version__ = "$Revision$"[11:-2]
__all__     = [""]

import pgdb

hostname = '10.0.0.20'
database = 'eemyle'
username = 'eemyle'
password = '3WJj7JcF'

cnx = pgdb.connect("%s:%s:%s:%s" % (hostname,
                                    database,
                                    username,
                                    password))

c = cnx.cursor()

# Get all servers id
c.execute('SELECT id_customer,id_server,name FROM servers ORDER BY id_customer,name')
id_servers = c.fetchall()

nb_server = len(id_servers)
nb_alone  = 0
nb_public = 0
nb_eth0   = 0
nb_error  = 0

for id_customer, id_server, name in id_servers:
    
    print 'Processing server %s from customer %s...' % (name, id_customer)
    c.execute('SELECT id_interface,name,ip,pub FROM interfaces WHERE id_server = %d ORDER BY name' % id_server)
    interfaces = c.fetchall()

    id_interface = None
    
    if len(interfaces) == 1:
        id, ifname, ip, public = interfaces[0]
        nb_alone    += 1
        id_interface = id
        print '  Only one interface (%s)' % ifname

    else:
        # Trying to find a public interface
        for id, ifname, ip, public in interfaces:
            if public:
                nb_public   += 1
                id_interface = id
                print '  Interface %s is public' % ifname
                break

        # Using eth0
        if not id_interface:
            for id, ifname, ip, public in interfaces:
                if ifname == 'eth0':
                    nb_eth0 += 1
                    id_interface = id
                    print '  Choosing interface eth0'


    if not id_interface:
        print '  Error: no interface found!!'
        nb_error += 1
    
    else:
        sql = 'UPDATE servers SET id_connection_interface = %d WHERE id_server = %d' % (id_interface, id_server)
        c.execute(sql)

print 'Number of servers:           %.3d' % nb_server
print 'Number of alone interfaces:  %.3d' % nb_alone
print 'Number of public interfaces: %.3d' % nb_public
print 'Number of eth0 interfaces:   %.3d' % nb_eth0
print 'Number of errors:            %.3d' % nb_error
print 'total:                       %.3d' % (nb_alone+nb_public+nb_eth0+nb_error)

#c.execute("INSERT INTO etc.")
c.close()
cnx.commit()


