#!/usr/bin/env python2
#
# GEemyle: A GTK frontend to Eemyle
# Copyright (C) 2003-2006 Easter-eggs <info@easter-eggs.com>
# Authors:
#      Cyril Lacoux (Yack) <clacoux@easter-eggs.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

__author__  = "Cyril Lacoux [Yack] <clacoux@easter-eggs.com>"
__cvsid__   = "$Id$"
__version__ = "$Revision$"[11:-2]
__all__     = [""]

import pgdb

hostname = '10.0.0.20'
database = 'eemyle'
username = 'eemyle'
password = '3WJj7JcF'

cnx = pgdb.connect("%s:%s:%s:%s" % (hostname,
                                    database,
                                    username,
                                    password))

c = cnx.cursor()

# Get all servers id
c.execute('SELECT id_customer,id_server,name,root_pass,admin_name,admin_pass,user_name,user_pass FROM servers ORDER BY id_customer,name')
servers = c.fetchall()

nb_server = len(servers)
nb_root   = 0
nb_admin  = 0
nb_user   = 0
nb_error  = 0

for id_customer, id_server, name, root_pass, admin_name, admin_pass, user_name, user_pass in servers:
    
    print 'Processing server %s from customer %s...' % (name, id_customer)

    if root_pass:
        sql = "INSERT into users (id_server, name, pass) VALUES (%d, 'root', '%s')" % (id_server, root_pass.replace("'", "\\'"))
        c.execute(sql)
    else:
        nb_root += 1
        
    if admin_name or admin_pass:
        sql = "INSERT into users (id_server, name, pass) VALUES (%d, '%s', '%s')" % (id_server, admin_name, admin_pass.replace("'", "\\'"))
        c.execute(sql)

        sql = "SELECT id_user FROM users WHERE id_server = %d AND name = '%s'" % (id_server, admin_name)
        c.execute(sql)
        id_user = c.fetchone()[0]

        sql = "UPDATE servers SET id_connection_user = %d WHERE id_server = %d" % (id_user, id_server)
        c.execute(sql)
    else:
        nb_admin += 1

    if user_name or user_pass:
        sql = "INSERT into users (id_server, name, pass) VALUES (%d, '%s', '%s')" % (id_server, user_name, user_pass.replace("'", "\\'"))
        c.execute(sql)
    else:
        nb_user += 1

print 'Number of servers:           %.3d' % nb_server
print 'Number of missing root pass: %.3d' % nb_root
print 'Number of missing admin:     %.3d' % nb_admin
print 'Number of missing user:      %.3d' % nb_user
print 'total:                       %.3d' % (nb_root+nb_admin+nb_user)

c.close()
cnx.commit()
